`include "fifo_par.v"

module multi_q_fifo (clk, rst, wen, ren, data,requeue, q, empty, full);

//------Parameters declaration:---------
	parameter  ADDRS   = 4;
	parameter  WIDTH   = 8;
	parameter  ADDRQ   = 2;    //NQUEUERS = 2**ADDRQ
//--------------------------------------

 //-----External signal declaration-----
	input    [WIDTH-1:0]         data;	//  
	input                        clk;
	input                        rst;	// 
	input    [(1 << ADDRQ)-1:0]  wen;	//   
	input                        ren;	//   
	input    [(1 << ADDRQ)-1:0]  requeue;	//     ( ,  ,   )

	output   [WIDTH-1:0]         q;		//  

	output   [(1 << ADDRQ)-1:0]  empty;	//  - "   "
	output   [(1 << ADDRQ)-1:0]  full;	//  - "   "
//---------------------------------------

 //-----internal signal declaration------
	wire     [WIDTH-1:0]         q_multi [(1 << ADDRQ)-1:0];
	reg      [WIDTH-1:0]         q_int;
	 
	reg      [ADDRQ-1:0]         req;
	reg                          renn;
	reg                          ren_mfifo;

	reg      [ADDRQ-1:0]         reqq;


	int j;
//---------------------------------------
	
		
//---------------------------------------
	generate
		genvar i;
		for (i=0; i<(1 << ADDRQ); i=i+1)
		begin : queue
		//	if(i==nqueue) begin
		//		ren_multi = ren;
		//   end;
		//	else
				//ren_multi = 0;
	//
			fifo_par #(ADDRS,WIDTH) fifo(
				.data(data),
				.clk(clk),
				.rst(rst),
				.wen(wen[i]),
				.ren(ren&requeue[i]),
				.q(q_multi[i]),
				.empty(empty[i]),
				.full(full[i])
				);
		end
	endgenerate

always @ (rst, requeue)
		begin
		   /* verilator lint_off COMBDLY */
		if(rst)	
			req <= 0;
		else if(requeue == 0) 
		   req <= 0;
		   else
		   		for(j=0;j<(1 << ADDRQ); j=j+1)
					if(requeue[j] == 1)
						req <= j;
//					else
//						req <=0;
		   /* verilator lint_off WIDTH*/
//			   req <= log2_8(requeue);
		end
//---------------------------------------


//------------------- ren  -----
always @(posedge clk, posedge rst)
begin
	if(rst)
		renn = 0;
	else 
		renn = ren;
end

always @(posedge clk, posedge rst)
begin
	if(rst)
		ren_mfifo = 0;
	else 
		ren_mfifo = renn;
end
//---------------------------------------


always @ (negedge clk, posedge rst) begin
	if(rst) 
		q_int = 0;
	else 
		if(renn)			
			q_int = q_multi[req];
			//q_int = 1;
		//else if (!ren)
		//	q_int = q_int;

end

//-------------------------------------------------------
	function integer log2_8;
  		
		input integer value;
 		 begin
   			case (value)
  				1 : log2_8 = 0;
				2 : log2_8 = 1;
				4 : log2_8 = 2;
				8 : log2_8 = 3;
			endcase
//----------------Universal log2--------
/*value = value-1;
    for (log2=0; value>0; log2=log2+1)
     	 value = value>>1;
 */	
//---------------------------------------
		end
	endfunction
//-------------------------------------------------------


//*/

	assign q = q_int;
	
	
	
endmodule
	
	
