/*Copyright 2010-2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

///////////////////////////////////////////////////////////////////////////////
// PROJECT:  C++TESK
// AUTHOR:   Alexander Protsenko (protsenko@ispras.ru)
// SYNOPSIS: 
///////////////////////////////////////////////////////////////////////////////

#pragma once

#include "hw/event.hpp"
#include "tunit.hpp"
#include "runit.hpp"
#include "rset.hpp"

#include <string>

namespace cpptesk {
namespace hw {
namespace diagnostics {

class Rule
{
    public:
    const static int FALSE_MATCH = 10000; // more then fuzzy rule
    const static int FUZZY_MATCH = 1000; // more then normal rule
    const static int EXACT_MATCH = 0;
  
    const static int NOT_FOUND_COLLAPSE_RULE = -1;
   
    Rule() {}
    virtual ~Rule() {}

    virtual ReactionSet transform(::cpptesk::hw::diagnostics::ReactionUnit &_reactionUnit_1, ::cpptesk::hw::diagnostics::ReactionUnit &_reactionUnit_2)
    // Collapse the reactions
    {
        CPPTESK_UNUSED_ARG(_reactionUnit_1);
        CPPTESK_UNUSED_ARG(_reactionUnit_2);
        ReactionSet rs;
        return rs;
    }

    virtual int match(::cpptesk::hw::Reaction _reaction_1, ::cpptesk::hw::Reaction _reaction_2)
    // Compare the reactions
    {
        CPPTESK_UNUSED_ARG(_reaction_1);
        CPPTESK_UNUSED_ARG(_reaction_2);
        return NOT_FOUND_COLLAPSE_RULE;
    }

    virtual void weight()
    // Get the weight of operation
    {
    }

    virtual void distance()
    //  
    {
    }

    virtual std::string getRuleDescription()
    {
        return "Empty";
    }

    virtual void setCollapseRule(::cpptesk::hw::diagnostics::ReactionUnit &_reactionUnit_1, ::cpptesk::hw::diagnostics::ReactionUnit &_reactionUnit_2, int _rule)
    // Get the weight of operation
    {
        CPPTESK_UNUSED_ARG(_reactionUnit_1);
        CPPTESK_UNUSED_ARG(_reactionUnit_2);
        CPPTESK_UNUSED_ARG(_rule);
    }
};

}}}

