/** @file counter_scen.cpp
 * This file contains implementation of the scenario class.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#include <counter_scen.h>

namespace cpptesk {
namespace examples {
namespace counter {

bool CounterScenario::init(int argc, char ** argv)
{
    UNUSED_ARG(argc);
    UNUSED_ARG(argv);

    dut.initialize();
    return true;
}

void CounterScenario::finish()
{
    dut.finalize();
}

bool CounterScenario::scen_inc(Ctx& ctx)
{
    InputData msg;

    ITERATION_BEGIN

    ITERATION_ACTION
    {
        dut.refresh_coverage();

        msg = InputData(dut.OP1, dut.time());

        dut.start(&Counter::inc, dut.iface1, msg, Counter::START_REQUEST_IFACE);
        dut.cycle();

        ITERATION_YIELD(dut.verdict());
    }
    ITERATION_END
}

std::string CounterScenario::get_state_counter()
{
    std::string state;
    std::stringstream out;

    out << "{counter:" << refcurrentstate /*dut.get_value()*/ << "}";
    state = out.str();

    DEBUG_PRINTF(cpptesk::hw::DEBUG_USER, "get_state_counter(): %s", state.c_str());

    return state;
}

CounterScenario::CounterScenario(void) : ScenarioBase()
{
}
CounterScenario::~CounterScenario(void) {}

ExampleScenario::ExampleScenario(void) : CounterScenario()
{
    setup("CounterScenario", &CounterScenario::init, &CounterScenario::finish, &CounterScenario::get_state_counter);

    ADD_SCENARIO_METHOD(CounterScenario::scen_inc);
}
ExampleScenario::~ExampleScenario(void) { };

}}}
